#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH]="19.05.03";

#define BAD_WORD 	100
#define SANCTION	6

new g_BadWordsCFG[MAX_TEXT_LENGTH]="addons/adminmod/config/chatfilter/badwords.cfg";
new g_iBadWords;

new g_BadWords[BAD_WORD][MAX_TEXT_LENGTH];
new g_BWAnswer[BAD_WORD][MAX_TEXT_LENGTH];
new g_BWWarnPoints[BAD_WORD][MAX_NUMBER_LENGTH];
new g_Warning[MAX_PLAYERS];

new g_slap;
new g_slay;
new g_kick;
new g_ban;
new g_ban_min;

/*
 * Der folgende Part soll nun das Handling der Einstellungen aus der Konsole ermoeglichen
 * Dieser Teil hat betastatus !!!
 */

stock SetVaultInts(sParam[],iValue){
    new sVaultData[MAX_DATA_LENGTH];

    snprintf(sVaultData,MAX_DATA_LENGTH,"%d",iValue);
    set_vaultdata(sParam,sVaultData);
}

stock SaveConfigurations(){
    SetVaultInts("CHATFILTER_SLAP",g_slap);
    SetVaultInts("CHATFILTER_SLAY",g_slay);
    SetVaultInts("CHATFILTER_KICK",g_kick);
    SetVaultInts("CHATFILTER_BAN",g_ban);
    SetVaultInts("CHATFILTER_BAN_MIN",g_ban_min);
}

DisplayParamValues(sDesc[],iValue){
    new s[MAX_TEXT_LENGTH];
    snprintf(s, MAX_TEXT_LENGTH, "CHATFILTER: %s is %d.", sDesc, iValue);
    selfmessage(s);
}

public admin_chfilter(HLCommand,HLData,HLUserName,UserIndex){
    new sData[MAX_DATA_LENGTH];
    new sCommand[MAX_DATA_LENGTH];
    new sArgument[MAX_DATA_LENGTH];
    new iDisplayStatus = 0;
    convert_string(HLData, sData, MAX_DATA_LENGTH);
    strinit(sCommand);
    strinit(sArgument);
    if (!strlen(sData)){
        if (!access(ACCESS_BAN,"")){
            iDisplayStatus = 1;
        }else{
            err(3,"");
            return PLUGIN_HANDLED;
        }
    }else{
        strsplit(sData," ",sCommand,MAX_DATA_LENGTH,sArgument,MAX_DATA_LENGTH);
    }
    if(!access(ACCESS_BAN,"")){
        selfmessage("CHATFILTER: You are not allowed to use this command");
        return PLUGIN_HANDLED;
    }
    if(streq(sCommand,"help")){
        err(3,"");
        return PLUGIN_HANDLED;
    }
    if(streq(sCommand,"slap") || iDisplayStatus){
        if(strlen(sArgument)){
            g_slap = strtonum(sArgument);
            SaveConfigurations();
        }
    	DisplayParamValues("Limit before slapping",g_slap);
    }
    if(streq(sCommand,"slay") || iDisplayStatus){
        if(strlen(sArgument)){
            g_slay = strtonum(sArgument);
            SaveConfigurations();
        }
       	DisplayParamValues("Limit before slaying",g_slay);
	}
	if(streq(sCommand,"kick") || iDisplayStatus){
        if(strlen(sArgument)){
            g_kick = strtonum(sArgument);
            SaveConfigurations();
        }
	    DisplayParamValues("Limit before kicking",g_kick);
    }
    if(streq(sCommand,"ban") || iDisplayStatus){
        if(strlen(sArgument)){
            g_ban = strtonum(sArgument);
            SaveConfigurations();
        }
        DisplayParamValues("Limit before banning",g_ban);
    }
  	if(streq(sCommand,"ban_min") || iDisplayStatus){
        if(strlen(sArgument)){
            g_ban_min = strtonum(sArgument);
            SaveConfigurations();
        }
        DisplayParamValues("Bantime after bad words",g_ban_min);
    }
    return PLUGIN_HANDLED;
}

/* Ende Konsoleneingabeteil */


public HSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new i;

	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_DATA_LENGTH);

	strstripquotes(Data);

	if(strlen(Data)!=0){
		for(i=0;i<=g_iBadWords;i++){
			if(strcasestrx(Data,g_BadWords[i])!=-1){
				sanction(User,UserIndex,i);
				return PLUGIN_HANDLED;
				break;
			}
		}

	}
	return PLUGIN_CONTINUE;
}

sanction(UserName[],UserIndex,ArrayIndex){
	new Text[MAX_TEXT_LENGTH];
	new warning;
	messageex(UserName,g_BWAnswer[ArrayIndex],print_chat);
	warning=strtonum(g_BWWarnPoints[ArrayIndex]);
	if(warning>0){
		g_Warning[UserIndex]+=warning;
		if(g_Warning[UserIndex]<g_slap){
			snprintf(Text,MAX_TEXT_LENGTH,"Du hast jetzt %i. Strafpunkt(e). Ab %i wird geslapt!",g_Warning[UserIndex],g_slap);
			messageex(UserName,Text,print_chat);
		}else if(g_Warning[UserIndex]>=g_slap && g_Warning[UserIndex]<g_slay){
			snprintf(Text,MAX_TEXT_LENGTH,"Du hast jetzt %i. Strafpunkte! Resultat: SLAP! Ab %i Punkten wirst Du aussetzen!",g_Warning[UserIndex],g_slay);
			slap(UserName);
			messageex(UserName,Text,print_chat);
		}else if(g_Warning[UserIndex]>=g_slay && g_Warning[UserIndex]<g_kick){
			snprintf(Text,MAX_TEXT_LENGTH,"Du hast jetzt %i. Strafpunkte! Resultat: SLAY! Ab %i Punkten kommt der KICK!",g_Warning[UserIndex],g_kick);
			slay(UserName);
			messageex(UserName,Text,print_chat);
		}else if(g_Warning[UserIndex]>=g_kick && g_Warning[UserIndex]<g_ban){
			snprintf(Text,MAX_TEXT_LENGTH,"Du hast %i. Strafpunkte erreicht! Resultat: KICK! Du hast es ja nicht anders gewollt!",g_Warning[UserIndex]);
			messageex(UserName,g_BWAnswer[ArrayIndex],print_console);
			messageex(UserName,Text,print_console);
			kick(UserName);
		}else if(g_Warning[UserIndex]>=g_ban){
			snprintf(Text,MAX_TEXT_LENGTH,"Du hast %i. Strafpunkte erreicht! Resultat: BAN! Du hast es ja nicht anders gewollt!",g_Warning[UserIndex]);
			messageex(UserName,g_BWAnswer[ArrayIndex],print_console);
			messageex(UserName,Text,print_console);
			ban(UserName,g_ban_min,bBanByID);
		}
	}
}

public plugin_disconnect(HLUserName,UserIndex) {
	g_Warning[UserIndex]=0;
	return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName,HLIP, UserIndex) {
	g_Warning[UserIndex]=0;
	return PLUGIN_CONTINUE;
}

read_files(){
	new Data[MAX_TEXT_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new i;
	new j;

	if(fileexists(g_BadWordsCFG)){
		g_iBadWords=0;
		j=filesize(g_BadWordsCFG);
		if(j>99){
			j=99;
		}
		for(i=1;i<=j;i++){
			readfile(g_BadWordsCFG,Data,i,MAX_TEXT_LENGTH);
			strsplit(Data,":",g_BadWords[i],MAX_TEXT_LENGTH,g_BWAnswer[i],MAX_TEXT_LENGTH,g_BWWarnPoints[i],MAX_NUMBER_LENGTH);
			g_iBadWords++;
		}
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL-CHAT-FILTER] Es wurden %i Woerter und Antworten geladen!",g_iBadWords);
		selfmessage(Text);
	}else{
		selfmessage("[SDAL-CHATFILTER] Konnte Filter-Datei nicht finden! Bitte kontrollieren");
	}
	return PLUGIN_CONTINUE;
}

/*
 * Einstellungsfeedback ebenfalls Beta by Stills
 */

public err(a,Command[]){
	new Text[MAX_TEXT_LENGTH];
	new VaultEntry[MAX_TEXT_LENGTH];


	if (a==2){
		snprintf(Text,MAX_TEXT_LENGTH,"Chatfilter: command %s is not valid",Command);
		selfmessage(Text);
	}else if (a==3){
		selfmessage("--- PLUGIN-CHATFILTER-Help ---");
		selfmessage("These values are set in vault.ini:");
		get_vaultdata("CHATFILTER_SLAP",VaultEntry,MAX_TEXT_LENGTH);
		snprintf(Text,MAX_TEXT_LENGTH,"CHATFILTER_SLAP is setz to %s",VaultEntry);
		selfmessage(Text);
		get_vaultdata("CHATFILTER_SLAY",VaultEntry,MAX_TEXT_LENGTH);
		snprintf(Text,MAX_TEXT_LENGTH,"CHATFILTER_SLAY is set to %s",VaultEntry);
		selfmessage(Text);
		get_vaultdata("CHATFILTER_KICK",VaultEntry,MAX_TEXT_LENGTH);
		snprintf(Text,MAX_TEXT_LENGTH,"CHATFILTER_KICK is set to %s",VaultEntry);
		selfmessage(Text);
		get_vaultdata("CHATFILTER_BAN",VaultEntry,MAX_TEXT_LENGTH);
		snprintf(Text,MAX_TEXT_LENGTH,"CHATFILTER_BAN is set to %s",VaultEntry);
		selfmessage(Text);
		get_vaultdata("CHATFILTER_BAN_MIN",VaultEntry,MAX_TEXT_LENGTH);
		snprintf(Text,MAX_TEXT_LENGTH,"CHATFILTER_BAN_TIME is set to %s",VaultEntry);
		selfmessage(Text);
		selfmessage("");
		selfmessage("To change these values, use following commands:");
		selfmessage("admin_chfilter <COMMAND> <VALUE>");
		selfmessage("admin_chfilter slap <value> Points of punishing after wich slapping for bad words");
		selfmessage("admin_chfilter slay <value> Points of punishing after wich slaying for bad words");
		selfmessage("admin_chfilter kick <value> Points of punishing after wich kicking for bad words");
		selfmessage("admin_chfilter ban <value> Points of punishing after wich banning for bad words");
		selfmessage("admin_chfilter ban_min <value> Minutes of the bantime, 0 is a permanent ban");
		selfmessage("");
	}
	return PLUGIN_HANDLED;
}

/* Ende Einstellungsfeedback */

public plugin_init() {
	plugin_registerinfo("SDals Chat Filter V3.01beta (Stills)","It filters the bad words and reacts correspondingly to it",STRING_VERSION);
	plugin_registercmd("admin_chfilter","admin_chfilter",ACCESS_BAN,"admin_chfilter <command> <value>: Set the settings for badword retribution");
	plugin_registercmd("say","HSay",ACCESS_ALL);
	plugin_registercmd("say_team","HSay",ACCESS_ALL);
	read_files();
	get_vaultnumdata("CHATFILTER_SLAP",g_slap);
	get_vaultnumdata("CHATFILTER_SLAY",g_slay);
	get_vaultnumdata("CHATFILTER_KICK",g_kick);
	get_vaultnumdata("CHATFILTER_BAN",g_ban);
	get_vaultnumdata("CHATFILTER_BAN_MIN",g_ban_min);
	return PLUGIN_CONTINUE;
}